
_DelaySub:

;delay.h,3 :: 		void DelaySub(unsigned int ms)                                                         // Subroutine called by
;delay.h,7 :: 		for (i = 0; i < ms; i++)                                  //  Simple Delay Loop
	CLRF       R1+0
	CLRF       R1+1
L_DelaySub0:
	MOVF       FARG_DelaySub_ms+1, 0
	SUBWF      R1+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__DelaySub65
	MOVF       FARG_DelaySub_ms+0, 0
	SUBWF      R1+0, 0
L__DelaySub65:
	BTFSC      STATUS+0, 0
	GOTO       L_DelaySub1
;delay.h,8 :: 		for (j = 0; j < ms; j++);                         //Approx 0.1 second
	CLRF       R3+0
	CLRF       R3+1
L_DelaySub3:
	MOVF       FARG_DelaySub_ms+1, 0
	SUBWF      R3+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__DelaySub66
	MOVF       FARG_DelaySub_ms+0, 0
	SUBWF      R3+0, 0
L__DelaySub66:
	BTFSC      STATUS+0, 0
	GOTO       L_DelaySub4
	INCF       R3+0, 1
	BTFSC      STATUS+0, 2
	INCF       R3+1, 1
	GOTO       L_DelaySub3
L_DelaySub4:
;delay.h,7 :: 		for (i = 0; i < ms; i++)                                  //  Simple Delay Loop
	INCF       R1+0, 1
	BTFSC      STATUS+0, 2
	INCF       R1+1, 1
;delay.h,8 :: 		for (j = 0; j < ms; j++);                         //Approx 0.1 second
	GOTO       L_DelaySub0
L_DelaySub1:
;delay.h,11 :: 		} // End DelayFunction
L_end_DelaySub:
	RETURN
; end of _DelaySub

_Delay5ms:

;delay.h,13 :: 		void Delay5ms()
;delay.h,15 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_Delay5ms6:
	DECFSZ     R13+0, 1
	GOTO       L_Delay5ms6
	DECFSZ     R12+0, 1
	GOTO       L_Delay5ms6
	NOP
	NOP
;delay.h,16 :: 		}
L_end_Delay5ms:
	RETURN
; end of _Delay5ms

_Delay10ms:

;delay.h,18 :: 		void Delay10ms()
;delay.h,20 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_Delay10ms7:
	DECFSZ     R13+0, 1
	GOTO       L_Delay10ms7
	DECFSZ     R12+0, 1
	GOTO       L_Delay10ms7
	NOP
;delay.h,21 :: 		}
L_end_Delay10ms:
	RETURN
; end of _Delay10ms

_Delay50ms:

;delay.h,23 :: 		void Delay50ms()
;delay.h,25 :: 		Delay_ms(50);
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_Delay50ms8:
	DECFSZ     R13+0, 1
	GOTO       L_Delay50ms8
	DECFSZ     R12+0, 1
	GOTO       L_Delay50ms8
	NOP
	NOP
;delay.h,26 :: 		}
L_end_Delay50ms:
	RETURN
; end of _Delay50ms

_Delay100ms:

;delay.h,28 :: 		void Delay100ms()
;delay.h,30 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_Delay100ms9:
	DECFSZ     R13+0, 1
	GOTO       L_Delay100ms9
	DECFSZ     R12+0, 1
	GOTO       L_Delay100ms9
	DECFSZ     R11+0, 1
	GOTO       L_Delay100ms9
	NOP
;delay.h,31 :: 		}
L_end_Delay100ms:
	RETURN
; end of _Delay100ms

_Delay250ms:

;delay.h,33 :: 		void Delay250ms()
;delay.h,35 :: 		Delay_ms(250);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_Delay250ms10:
	DECFSZ     R13+0, 1
	GOTO       L_Delay250ms10
	DECFSZ     R12+0, 1
	GOTO       L_Delay250ms10
	DECFSZ     R11+0, 1
	GOTO       L_Delay250ms10
	NOP
	NOP
;delay.h,36 :: 		}
L_end_Delay250ms:
	RETURN
; end of _Delay250ms

_Delay500ms:

;delay.h,38 :: 		void Delay500ms()
;delay.h,40 :: 		Delay_ms(500);
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_Delay500ms11:
	DECFSZ     R13+0, 1
	GOTO       L_Delay500ms11
	DECFSZ     R12+0, 1
	GOTO       L_Delay500ms11
	DECFSZ     R11+0, 1
	GOTO       L_Delay500ms11
	NOP
	NOP
;delay.h,41 :: 		}
L_end_Delay500ms:
	RETURN
; end of _Delay500ms

_Delay750ms:

;delay.h,43 :: 		void Delay750ms()
;delay.h,45 :: 		Delay_ms(750);
	MOVLW      8
	MOVWF      R11+0
	MOVLW      157
	MOVWF      R12+0
	MOVLW      5
	MOVWF      R13+0
L_Delay750ms12:
	DECFSZ     R13+0, 1
	GOTO       L_Delay750ms12
	DECFSZ     R12+0, 1
	GOTO       L_Delay750ms12
	DECFSZ     R11+0, 1
	GOTO       L_Delay750ms12
	NOP
	NOP
;delay.h,46 :: 		}
L_end_Delay750ms:
	RETURN
; end of _Delay750ms

_Delay1000ms:

;delay.h,48 :: 		void Delay1000ms()
;delay.h,50 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_Delay1000ms13:
	DECFSZ     R13+0, 1
	GOTO       L_Delay1000ms13
	DECFSZ     R12+0, 1
	GOTO       L_Delay1000ms13
	DECFSZ     R11+0, 1
	GOTO       L_Delay1000ms13
	NOP
	NOP
;delay.h,51 :: 		}
L_end_Delay1000ms:
	RETURN
; end of _Delay1000ms

_Delay1500ms:

;delay.h,53 :: 		void Delay1500ms()
;delay.h,55 :: 		Delay_ms(1500);
	MOVLW      16
	MOVWF      R11+0
	MOVLW      57
	MOVWF      R12+0
	MOVLW      13
	MOVWF      R13+0
L_Delay1500ms14:
	DECFSZ     R13+0, 1
	GOTO       L_Delay1500ms14
	DECFSZ     R12+0, 1
	GOTO       L_Delay1500ms14
	DECFSZ     R11+0, 1
	GOTO       L_Delay1500ms14
	NOP
	NOP
;delay.h,56 :: 		}
L_end_Delay1500ms:
	RETURN
; end of _Delay1500ms

_Delay2000ms:

;delay.h,58 :: 		void Delay2000ms()
;delay.h,60 :: 		Delay_ms(2000);
	MOVLW      21
	MOVWF      R11+0
	MOVLW      75
	MOVWF      R12+0
	MOVLW      190
	MOVWF      R13+0
L_Delay2000ms15:
	DECFSZ     R13+0, 1
	GOTO       L_Delay2000ms15
	DECFSZ     R12+0, 1
	GOTO       L_Delay2000ms15
	DECFSZ     R11+0, 1
	GOTO       L_Delay2000ms15
	NOP
;delay.h,61 :: 		}
L_end_Delay2000ms:
	RETURN
; end of _Delay2000ms

_Delay2ms:

;delay.h,63 :: 		void Delay2ms()
;delay.h,65 :: 		Delay_ms(2);
	MOVLW      6
	MOVWF      R12+0
	MOVLW      48
	MOVWF      R13+0
L_Delay2ms16:
	DECFSZ     R13+0, 1
	GOTO       L_Delay2ms16
	DECFSZ     R12+0, 1
	GOTO       L_Delay2ms16
	NOP
;delay.h,66 :: 		}//****************************************************************************
L_end_Delay2ms:
	RETURN
; end of _Delay2ms

_Delay5us:

;delay.h,67 :: 		void Delay5us()
;delay.h,69 :: 		Delay_us(5);
	MOVLW      3
	MOVWF      R13+0
L_Delay5us17:
	DECFSZ     R13+0, 1
	GOTO       L_Delay5us17
;delay.h,70 :: 		}
L_end_Delay5us:
	RETURN
; end of _Delay5us

_Delay10us:

;delay.h,72 :: 		void Delay10us()
;delay.h,74 :: 		Delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_Delay10us18:
	DECFSZ     R13+0, 1
	GOTO       L_Delay10us18
	NOP
;delay.h,75 :: 		}
L_end_Delay10us:
	RETURN
; end of _Delay10us

_Delay20us:

;delay.h,77 :: 		void Delay20us()
;delay.h,79 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L_Delay20us19:
	DECFSZ     R13+0, 1
	GOTO       L_Delay20us19
;delay.h,80 :: 		}//***************************************************************************
L_end_Delay20us:
	RETURN
; end of _Delay20us

_Delay200us:

;delay.h,81 :: 		void Delay200us()
;delay.h,83 :: 		Delay_us(200);
	MOVLW      133
	MOVWF      R13+0
L_Delay200us20:
	DECFSZ     R13+0, 1
	GOTO       L_Delay200us20
;delay.h,84 :: 		}
L_end_Delay200us:
	RETURN
; end of _Delay200us

_Delay250us:

;delay.h,86 :: 		void Delay250us()
;delay.h,88 :: 		Delay_us(250);
	MOVLW      166
	MOVWF      R13+0
L_Delay250us21:
	DECFSZ     R13+0, 1
	GOTO       L_Delay250us21
	NOP
;delay.h,89 :: 		}
L_end_Delay250us:
	RETURN
; end of _Delay250us

_Delay300us:

;delay.h,91 :: 		void Delay300us()
;delay.h,93 :: 		Delay_us(300);
	MOVLW      199
	MOVWF      R13+0
L_Delay300us22:
	DECFSZ     R13+0, 1
	GOTO       L_Delay300us22
	NOP
	NOP
;delay.h,94 :: 		}
L_end_Delay300us:
	RETURN
; end of _Delay300us

_shiftRight:

;x10.h,35 :: 		char shiftRight(char number)
;x10.h,37 :: 		return number >>= 1;
	MOVF       FARG_shiftRight_number+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVF       R0+0, 0
	MOVWF      FARG_shiftRight_number+0
;x10.h,38 :: 		}
L_end_shiftRight:
	RETURN
; end of _shiftRight

_Rcv_Data:

;x10.h,40 :: 		char Rcv_Data()
;x10.h,42 :: 		return (!RCV_FROM_X10);
	BTFSC      PORTA+0, 2
	GOTO       L__Rcv_Data86
	BSF        3, 0
	GOTO       L__Rcv_Data87
L__Rcv_Data86:
	BCF        3, 0
L__Rcv_Data87:
	MOVLW      0
	BTFSC      3, 0
	MOVLW      1
	MOVWF      R0+0
;x10.h,43 :: 		}
L_end_Rcv_Data:
	RETURN
; end of _Rcv_Data

_wait_for_zero_crossing:

;x10.h,45 :: 		void wait_for_zero_crossing()
;x10.h,47 :: 		if(Zero_Crossing)
	BTFSS      PORTA+0, 0
	GOTO       L_wait_for_zero_crossing23
;x10.h,48 :: 		while(Zero_Crossing) ;
L_wait_for_zero_crossing24:
	BTFSS      PORTA+0, 0
	GOTO       L_wait_for_zero_crossing25
	GOTO       L_wait_for_zero_crossing24
L_wait_for_zero_crossing25:
	GOTO       L_wait_for_zero_crossing26
L_wait_for_zero_crossing23:
;x10.h,50 :: 		while(!Zero_Crossing) ;
L_wait_for_zero_crossing27:
	BTFSC      PORTA+0, 0
	GOTO       L_wait_for_zero_crossing28
	GOTO       L_wait_for_zero_crossing27
L_wait_for_zero_crossing28:
L_wait_for_zero_crossing26:
;x10.h,51 :: 		}
L_end_wait_for_zero_crossing:
	RETURN
; end of _wait_for_zero_crossing

_x10_write_bits:

;x10.h,53 :: 		void x10_write_bits(char datam, char numofbits, char startbit)
;x10.h,57 :: 		for(loopcount = 1; loopcount <= numofbits; ++loopcount)
	MOVLW      1
	MOVWF      x10_write_bits_loopcount_L0+0
L_x10_write_bits29:
	MOVF       x10_write_bits_loopcount_L0+0, 0
	SUBWF      FARG_x10_write_bits_numofbits+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_x10_write_bits30
;x10.h,59 :: 		wait_for_zero_crossing();
	CALL       _wait_for_zero_crossing+0
;x10.h,60 :: 		datam = shiftRight(datam);
	MOVF       FARG_x10_write_bits_datam+0, 0
	MOVWF      FARG_shiftRight_number+0
	CALL       _shiftRight+0
	MOVF       R0+0, 0
	MOVWF      FARG_x10_write_bits_datam+0
;x10.h,61 :: 		TRANS_TO_X10 = datam.F0;
	BTFSC      FARG_x10_write_bits_datam+0, 0
	GOTO       L__x10_write_bits90
	BCF        PORTA+0, 1
	GOTO       L__x10_write_bits91
L__x10_write_bits90:
	BSF        PORTA+0, 1
L__x10_write_bits91:
;x10.h,62 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_x10_write_bits32:
	DECFSZ     R13+0, 1
	GOTO       L_x10_write_bits32
	DECFSZ     R12+0, 1
	GOTO       L_x10_write_bits32
	NOP
	NOP
;x10.h,63 :: 		TRANS_TO_X10 = 0;
	BCF        PORTA+0, 1
;x10.h,64 :: 		if(startbit == 0)
	MOVF       FARG_x10_write_bits_startbit+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_x10_write_bits33
;x10.h,66 :: 		wait_for_zero_crossing();
	CALL       _wait_for_zero_crossing+0
;x10.h,67 :: 		TRANS_TO_X10 = !datam.F0;
	BTFSC      FARG_x10_write_bits_datam+0, 0
	GOTO       L__x10_write_bits92
	BSF        PORTA+0, 1
	GOTO       L__x10_write_bits93
L__x10_write_bits92:
	BCF        PORTA+0, 1
L__x10_write_bits93:
;x10.h,68 :: 		delay_ms(1);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_x10_write_bits34:
	DECFSZ     R13+0, 1
	GOTO       L_x10_write_bits34
	DECFSZ     R12+0, 1
	GOTO       L_x10_write_bits34
	NOP
	NOP
;x10.h,69 :: 		TRANS_TO_X10 = 0;
	BCF        PORTA+0, 1
;x10.h,70 :: 		}
L_x10_write_bits33:
;x10.h,57 :: 		for(loopcount = 1; loopcount <= numofbits; ++loopcount)
	INCF       x10_write_bits_loopcount_L0+0, 1
;x10.h,71 :: 		}
	GOTO       L_x10_write_bits29
L_x10_write_bits30:
;x10.h,72 :: 		return;
;x10.h,73 :: 		}
L_end_x10_write_bits:
	RETURN
; end of _x10_write_bits

_x10_write:

;x10.h,75 :: 		void x10_write(char house_code2, char key_code2)
;x10.h,78 :: 		i = 0;
	CLRF       x10_write_i_L0+0
;x10.h,79 :: 		while (House_Code_Table[i] != house_code2)
L_x10_write35:
	MOVF       x10_write_i_L0+0, 0
	ADDLW      _House_Code_Table+0
	MOVWF      R0+0
	MOVLW      hi_addr(_House_Code_Table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORWF      FARG_x10_write_house_code2+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_x10_write36
;x10.h,80 :: 		i++;
	INCF       x10_write_i_L0+0, 1
	GOTO       L_x10_write35
L_x10_write36:
;x10.h,81 :: 		house_code2 = i;
	MOVF       x10_write_i_L0+0, 0
	MOVWF      FARG_x10_write_house_code2+0
;x10.h,82 :: 		if(key_code2 < 16)
	MOVLW      16
	SUBWF      FARG_x10_write_key_code2+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_x10_write37
;x10.h,84 :: 		i = 0;
	CLRF       x10_write_i_L0+0
;x10.h,85 :: 		while (Key_Code_Table[i] != key_code2)
L_x10_write38:
	MOVF       x10_write_i_L0+0, 0
	ADDLW      _Key_Code_Table+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Key_Code_Table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORWF      FARG_x10_write_key_code2+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_x10_write39
;x10.h,86 :: 		i++;
	INCF       x10_write_i_L0+0, 1
	GOTO       L_x10_write38
L_x10_write39:
;x10.h,87 :: 		key_code2 = i;
	MOVF       x10_write_i_L0+0, 0
	MOVWF      FARG_x10_write_key_code2+0
;x10.h,88 :: 		}
L_x10_write37:
;x10.h,89 :: 		x10_write_bits(7 * 2, 4, 1);
	MOVLW      14
	MOVWF      FARG_x10_write_bits_datam+0
	MOVLW      4
	MOVWF      FARG_x10_write_bits_numofbits+0
	MOVLW      1
	MOVWF      FARG_x10_write_bits_startbit+0
	CALL       _x10_write_bits+0
;x10.h,90 :: 		x10_write_bits(house_code2 * 2, 4, 0);
	MOVF       FARG_x10_write_house_code2+0, 0
	MOVWF      FARG_x10_write_bits_datam+0
	RLF        FARG_x10_write_bits_datam+0, 1
	BCF        FARG_x10_write_bits_datam+0, 0
	MOVLW      4
	MOVWF      FARG_x10_write_bits_numofbits+0
	CLRF       FARG_x10_write_bits_startbit+0
	CALL       _x10_write_bits+0
;x10.h,91 :: 		x10_write_bits(key_code2 * 2, 5, 0);
	MOVF       FARG_x10_write_key_code2+0, 0
	MOVWF      FARG_x10_write_bits_datam+0
	RLF        FARG_x10_write_bits_datam+0, 1
	BCF        FARG_x10_write_bits_datam+0, 0
	MOVLW      5
	MOVWF      FARG_x10_write_bits_numofbits+0
	CLRF       FARG_x10_write_bits_startbit+0
	CALL       _x10_write_bits+0
;x10.h,92 :: 		x10_write_bits(0, 6, 1);
	CLRF       FARG_x10_write_bits_datam+0
	MOVLW      6
	MOVWF      FARG_x10_write_bits_numofbits+0
	MOVLW      1
	MOVWF      FARG_x10_write_bits_startbit+0
	CALL       _x10_write_bits+0
;x10.h,93 :: 		return;
;x10.h,94 :: 		}
L_end_x10_write:
	RETURN
; end of _x10_write

_x10_read_bits:

;x10.h,96 :: 		char x10_read_bits(char num)
;x10.h,100 :: 		for(ic = 1; ic <= num; ++ic)
	MOVLW      1
	MOVWF      x10_read_bits_ic_L0+0
L_x10_read_bits40:
	MOVF       x10_read_bits_ic_L0+0, 0
	SUBWF      FARG_x10_read_bits_num+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_x10_read_bits41
;x10.h,102 :: 		wait_for_zero_crossing();
	CALL       _wait_for_zero_crossing+0
;x10.h,103 :: 		delay_us(150);
	MOVLW      99
	MOVWF      R13+0
L_x10_read_bits43:
	DECFSZ     R13+0, 1
	GOTO       L_x10_read_bits43
	NOP
	NOP
;x10.h,104 :: 		if (RCV_FROM_X10 == 1)
	BTFSS      PORTA+0, 2
	GOTO       L_x10_read_bits44
;x10.h,106 :: 		setbit = 128;
	MOVLW      128
	MOVWF      _setbit+0
;x10.h,107 :: 		}
	GOTO       L_x10_read_bits45
L_x10_read_bits44:
;x10.h,110 :: 		setbit = 0;
	CLRF       _setbit+0
;x10.h,111 :: 		}
L_x10_read_bits45:
;x10.h,112 :: 		dataval = dataval + setbit;
	MOVF       _setbit+0, 0
	ADDWF      x10_read_bits_dataval_L0+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      x10_read_bits_dataval_L0+0
;x10.h,113 :: 		dataval = shiftRight(dataval);
	MOVF       R0+0, 0
	MOVWF      FARG_shiftRight_number+0
	CALL       _shiftRight+0
	MOVF       R0+0, 0
	MOVWF      x10_read_bits_dataval_L0+0
;x10.h,114 :: 		wait_for_zero_crossing();
	CALL       _wait_for_zero_crossing+0
;x10.h,115 :: 		delay_us(150);
	MOVLW      99
	MOVWF      R13+0
L_x10_read_bits46:
	DECFSZ     R13+0, 1
	GOTO       L_x10_read_bits46
	NOP
	NOP
;x10.h,100 :: 		for(ic = 1; ic <= num; ++ic)
	INCF       x10_read_bits_ic_L0+0, 1
;x10.h,116 :: 		}
	GOTO       L_x10_read_bits40
L_x10_read_bits41:
;x10.h,117 :: 		for(ic = 0; ic < 7 - num; ++ic)
	CLRF       x10_read_bits_ic_L0+0
L_x10_read_bits47:
	MOVF       FARG_x10_read_bits_num+0, 0
	SUBLW      7
	MOVWF      R1+0
	CLRF       R1+1
	BTFSS      STATUS+0, 0
	DECF       R1+1, 1
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__x10_read_bits96
	MOVF       R1+0, 0
	SUBWF      x10_read_bits_ic_L0+0, 0
L__x10_read_bits96:
	BTFSC      STATUS+0, 0
	GOTO       L_x10_read_bits48
;x10.h,119 :: 		dataval = shiftRight(dataval);
	MOVF       x10_read_bits_dataval_L0+0, 0
	MOVWF      FARG_shiftRight_number+0
	CALL       _shiftRight+0
	MOVF       R0+0, 0
	MOVWF      x10_read_bits_dataval_L0+0
;x10.h,117 :: 		for(ic = 0; ic < 7 - num; ++ic)
	INCF       x10_read_bits_ic_L0+0, 1
;x10.h,120 :: 		}
	GOTO       L_x10_read_bits47
L_x10_read_bits48:
;x10.h,121 :: 		return(dataval);
	MOVF       x10_read_bits_dataval_L0+0, 0
	MOVWF      R0+0
;x10.h,122 :: 		}
L_end_x10_read_bits:
	RETURN
; end of _x10_read_bits

_x10_read:

;x10.h,124 :: 		void x10_read()   //(char house_code, char key_code)
;x10.h,126 :: 		x10_read_bits(2);
	MOVLW      2
	MOVWF      FARG_x10_read_bits_num+0
	CALL       _x10_read_bits+0
;x10.h,127 :: 		house_code = x10_read_bits(4);
	MOVLW      4
	MOVWF      FARG_x10_read_bits_num+0
	CALL       _x10_read_bits+0
	MOVF       R0+0, 0
	MOVWF      _house_code+0
;x10.h,128 :: 		house_code = House_Code_Table[house_code];
	MOVLW      0
	MOVWF      R0+1
	MOVLW      _House_Code_Table+0
	ADDWF      R0+0, 1
	MOVLW      hi_addr(_House_Code_Table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      _house_code+0
;x10.h,129 :: 		key_code   = x10_read_bits(5);
	MOVLW      5
	MOVWF      FARG_x10_read_bits_num+0
	CALL       _x10_read_bits+0
	MOVF       R0+0, 0
	MOVWF      _key_code+0
;x10.h,130 :: 		if(key_code < 16)
	MOVLW      16
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_x10_read50
;x10.h,131 :: 		key_code = Key_Code_Table[key_code];
	MOVF       _key_code+0, 0
	ADDLW      _Key_Code_Table+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Key_Code_Table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      _key_code+0
L_x10_read50:
;x10.h,132 :: 		}
L_end_x10_read:
	RETURN
; end of _x10_read

_x10Trans:

;x10.h,134 :: 		void x10Trans(char House, char Chan, char OnOff)
;x10.h,136 :: 		x10_write(House, Chan);       // Send House and Channel First
	MOVF       FARG_x10Trans_House+0, 0
	MOVWF      FARG_x10_write_house_code2+0
	MOVF       FARG_x10Trans_Chan+0, 0
	MOVWF      FARG_x10_write_key_code2+0
	CALL       _x10_write+0
;x10.h,137 :: 		x10_write(House, Chan);       // Must Transmit Data Twice
	MOVF       FARG_x10Trans_House+0, 0
	MOVWF      FARG_x10_write_house_code2+0
	MOVF       FARG_x10Trans_Chan+0, 0
	MOVWF      FARG_x10_write_key_code2+0
	CALL       _x10_write+0
;x10.h,138 :: 		Delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_x10Trans51:
	DECFSZ     R13+0, 1
	GOTO       L_x10Trans51
	DECFSZ     R12+0, 1
	GOTO       L_x10Trans51
	DECFSZ     R11+0, 1
	GOTO       L_x10Trans51
	NOP
	NOP
;x10.h,139 :: 		x10_write(House, OnOff);      // Send House and Key Code Next
	MOVF       FARG_x10Trans_House+0, 0
	MOVWF      FARG_x10_write_house_code2+0
	MOVF       FARG_x10Trans_OnOff+0, 0
	MOVWF      FARG_x10_write_key_code2+0
	CALL       _x10_write+0
;x10.h,140 :: 		x10_write(House, OnOff);      // Must Transmit Data Twice
	MOVF       FARG_x10Trans_House+0, 0
	MOVWF      FARG_x10_write_house_code2+0
	MOVF       FARG_x10Trans_OnOff+0, 0
	MOVWF      FARG_x10_write_key_code2+0
	CALL       _x10_write+0
;x10.h,141 :: 		}
L_end_x10Trans:
	RETURN
; end of _x10Trans

_Display_X10:

;x10.h,143 :: 		void Display_X10(char row, char HousePos, char ChanPos, char StatusPos)
;x10.h,145 :: 		if(Rcv_Data())
	CALL       _Rcv_Data+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_Display_X1052
;x10.h,147 :: 		x10_read();                           // Read Pulses from PSC05
	CALL       _x10_read+0
;x10.h,149 :: 		if (key_code < 19)                    // If valid Chan Number
	MOVLW      19
	SUBWF      _key_code+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_Display_X1053
;x10.h,151 :: 		temp = key_code;
	MOVF       _key_code+0, 0
	MOVWF      _temp+0
;x10.h,152 :: 		}
L_Display_X1053:
;x10.h,154 :: 		LCD_Chr(row, HousePos, house_code);            // Display House Code
	MOVF       FARG_Display_X10_row+0, 0
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       FARG_Display_X10_HousePos+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       _house_code+0, 0
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;x10.h,155 :: 		BytetoStr(temp, txt4);
	MOVF       _temp+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _txt4+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;x10.h,156 :: 		LCD_Out(row, ChanPos, txt4);
	MOVF       FARG_Display_X10_row+0, 0
	MOVWF      FARG_Lcd_Out_row+0
	MOVF       FARG_Display_X10_ChanPos+0, 0
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt4+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10.h,157 :: 		if (key_code == 20) LCD_Out(row, StatusPos, "ON "); // Display ON
	MOVF       _key_code+0, 0
	XORLW      20
	BTFSS      STATUS+0, 2
	GOTO       L_Display_X1054
	MOVF       FARG_Display_X10_row+0, 0
	MOVWF      FARG_Lcd_Out_row+0
	MOVF       FARG_Display_X10_StatusPos+0, 0
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
L_Display_X1054:
;x10.h,158 :: 		if (key_code == 28) LCD_Out(row, StatusPos, "OFF"); // Display OFF
	MOVF       _key_code+0, 0
	XORLW      28
	BTFSS      STATUS+0, 2
	GOTO       L_Display_X1055
	MOVF       FARG_Display_X10_row+0, 0
	MOVWF      FARG_Lcd_Out_row+0
	MOVF       FARG_Display_X10_StatusPos+0, 0
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
L_Display_X1055:
;x10.h,159 :: 		Delay1000ms();
	CALL       _Delay1000ms+0
;x10.h,160 :: 		}
L_Display_X1052:
;x10.h,161 :: 		}
L_end_Display_X10:
	RETURN
; end of _Display_X10

_DisplayMess1:

;x10Demo.c,53 :: 		void DisplayMess1()
;x10Demo.c,55 :: 		LCD_Out(1, 1, "HC  Dev  On/Off ");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr3_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,56 :: 		}
L_end_DisplayMess1:
	RETURN
; end of _DisplayMess1

_DisplayMess2:

;x10Demo.c,58 :: 		void DisplayMess2()
;x10Demo.c,60 :: 		LCD_Out(2, 1, "House 'A' Ch 10 ");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr4_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,61 :: 		}
L_end_DisplayMess2:
	RETURN
; end of _DisplayMess2

_DisplayMess3:

;x10Demo.c,63 :: 		void DisplayMess3()
;x10Demo.c,65 :: 		LCD_Out(2, 1, "                ");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr5_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,66 :: 		}
L_end_DisplayMess3:
	RETURN
; end of _DisplayMess3

_main:

;x10Demo.c,68 :: 		void main()
;x10Demo.c,71 :: 		ANSEL  =  0b00000000;
	CLRF       ANSEL+0
;x10Demo.c,72 :: 		ANSELH =  0b00000000;
	CLRF       ANSELH+0
;x10Demo.c,73 :: 		ADCON1 =  0b00000000;
	CLRF       ADCON1+0
;x10Demo.c,74 :: 		PORTA =   0b00000000;       //  Start with Everything Low
	CLRF       PORTA+0
;x10Demo.c,75 :: 		PORTB =   0b00000000;       //  Start with Everything Low
	CLRF       PORTB+0
;x10Demo.c,76 :: 		PORTC =   0b00000000;       //  Start with Everything Low
	CLRF       PORTC+0
;x10Demo.c,77 :: 		PORTD =   0b00000000;       //  Start with Everything Low
	CLRF       PORTD+0
;x10Demo.c,78 :: 		TRISA =   0b00000101;
	MOVLW      5
	MOVWF      TRISA+0
;x10Demo.c,79 :: 		TRISB =   0b00000000;
	CLRF       TRISB+0
;x10Demo.c,80 :: 		TRISC =   0b10111101;
	MOVLW      189
	MOVWF      TRISC+0
;x10Demo.c,81 :: 		TRISD =   0b11111111;
	MOVLW      255
	MOVWF      TRISD+0
;x10Demo.c,82 :: 		TRISE =   0b00000111;
	MOVLW      7
	MOVWF      TRISE+0
;x10Demo.c,83 :: 		Lcd_Init();                 // Initialize LCD EasyPIC5
	CALL       _Lcd_Init+0
;x10Demo.c,84 :: 		LCD_Cmd(_LCD_CLEAR);        // Clear display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;x10Demo.c,85 :: 		LCD_Cmd(_LCD_CURSOR_OFF);   // Turn cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;x10Demo.c,86 :: 		Delay1000ms();
	CALL       _Delay1000ms+0
;x10Demo.c,88 :: 		LCD_Out(1, 1, "X10 Demo Program");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr6_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,89 :: 		LCD_Out(2, 1, "for P16F887     ");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr7_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,90 :: 		Delay2000ms();
	CALL       _Delay2000ms+0
;x10Demo.c,91 :: 		DisplayMess1();
	CALL       _DisplayMess1+0
;x10Demo.c,92 :: 		DisplayMess3();
	CALL       _DisplayMess3+0
;x10Demo.c,95 :: 		while (1 == 1)
L_main56:
;x10Demo.c,97 :: 		if (PORTD.F0 == 0)
	BTFSC      PORTD+0, 0
	GOTO       L_main58
;x10Demo.c,99 :: 		while (PORTD.F0 == 0)
L_main59:
	BTFSC      PORTD+0, 0
	GOTO       L_main60
;x10Demo.c,101 :: 		}
	GOTO       L_main59
L_main60:
;x10Demo.c,102 :: 		LCD_Out(1, 1, "X10 Transmit ON ");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr8_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,103 :: 		DisplayMess2();
	CALL       _DisplayMess2+0
;x10Demo.c,104 :: 		x10Trans('A', 10, ON);    // House codes A - P,  Channels 0 - 15
	MOVLW      65
	MOVWF      FARG_x10Trans_House+0
	MOVLW      10
	MOVWF      FARG_x10Trans_Chan+0
	MOVLW      20
	MOVWF      FARG_x10Trans_OnOff+0
	CALL       _x10Trans+0
;x10Demo.c,105 :: 		Delay1000ms();
	CALL       _Delay1000ms+0
;x10Demo.c,106 :: 		DisplayMess1();
	CALL       _DisplayMess1+0
;x10Demo.c,107 :: 		DisplayMess3();
	CALL       _DisplayMess3+0
;x10Demo.c,108 :: 		}
L_main58:
;x10Demo.c,109 :: 		if (PORTD.F1 == 0)
	BTFSC      PORTD+0, 1
	GOTO       L_main61
;x10Demo.c,111 :: 		while (PORTD.F1 == 0)
L_main62:
	BTFSC      PORTD+0, 1
	GOTO       L_main63
;x10Demo.c,113 :: 		}
	GOTO       L_main62
L_main63:
;x10Demo.c,114 :: 		LCD_Out(1, 1, "X10 Transmit OFF");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr9_x10Demo+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;x10Demo.c,115 :: 		DisplayMess2();
	CALL       _DisplayMess2+0
;x10Demo.c,116 :: 		x10Trans('A', 10, OFF);   // House codes A - P,  Channels 0 - 15
	MOVLW      65
	MOVWF      FARG_x10Trans_House+0
	MOVLW      10
	MOVWF      FARG_x10Trans_Chan+0
	MOVLW      28
	MOVWF      FARG_x10Trans_OnOff+0
	CALL       _x10Trans+0
;x10Demo.c,117 :: 		Delay1000ms();
	CALL       _Delay1000ms+0
;x10Demo.c,118 :: 		DisplayMess1();
	CALL       _DisplayMess1+0
;x10Demo.c,119 :: 		DisplayMess3();
	CALL       _DisplayMess3+0
;x10Demo.c,120 :: 		}
L_main61:
;x10Demo.c,121 :: 		Display_X10(2, 1, 3, 8);  // Reads and Displays X10 Data
	MOVLW      2
	MOVWF      FARG_Display_X10_row+0
	MOVLW      1
	MOVWF      FARG_Display_X10_HousePos+0
	MOVLW      3
	MOVWF      FARG_Display_X10_ChanPos+0
	MOVLW      8
	MOVWF      FARG_Display_X10_StatusPos+0
	CALL       _Display_X10+0
;x10Demo.c,122 :: 		} // End While
	GOTO       L_main56
;x10Demo.c,123 :: 		} // End Main
L_end_main:
	GOTO       $+0
; end of _main
