#line 1 "C:/Evil Genius/MikroProC/P16F887/x10 Demo Program/x10Demo.c"
#line 1 "c:/evil genius/mikroproc/p16f887/x10 demo program/delay.h"


void DelaySub(unsigned int ms)

{
unsigned int i, j;
 for (i = 0; i < ms; i++)
 for (j = 0; j < ms; j++);


}

void Delay5ms()
{
Delay_ms(5);
}

void Delay10ms()
{
Delay_ms(10);
}

void Delay50ms()
{
Delay_ms(50);
}

void Delay100ms()
{
Delay_ms(100);
}

void Delay250ms()
{
Delay_ms(250);
}

void Delay500ms()
{
Delay_ms(500);
}

void Delay750ms()
{
Delay_ms(750);
}

void Delay1000ms()
{
Delay_ms(1000);
}

void Delay1500ms()
{
Delay_ms(1500);
}

void Delay2000ms()
{
Delay_ms(2000);
}

void Delay2ms()
{
Delay_ms(2);
}
void Delay5us()
{
Delay_us(5);
}

void Delay10us()
{
Delay_us(10);
}

void Delay20us()
{
Delay_us(20);
}
void Delay200us()
{
Delay_us(200);
}

void Delay250us()
{
Delay_us(250);
}

void Delay300us()
{
Delay_us(300);
}
#line 1 "c:/evil genius/mikroproc/p16f887/x10 demo program/x10.h"
#line 28 "c:/evil genius/mikroproc/p16f887/x10 demo program/x10.h"
char const House_Code_Table[17] = {'M','N','O','P','C','D','A','B','E',
 'F','G','H','K','L','I','J'};
char const Key_Code_Table[17] = {13, 14, 15, 16, 3, 4, 1, 2, 5, 6, 7,
 8, 11, 12, 9, 10};
char txt4[4], temp, setbit;
char house_code, key_code;

char shiftRight(char number)
{
 return number >>= 1;
}

char Rcv_Data()
{
 return (! PORTA.F2 );
}

void wait_for_zero_crossing()
{
 if( PORTA.F0 )
 while( PORTA.F0 ) ;
 else
 while(! PORTA.F0 ) ;
}

void x10_write_bits(char datam, char numofbits, char startbit)
{
 char loopcount;

 for(loopcount = 1; loopcount <= numofbits; ++loopcount)
 {
 wait_for_zero_crossing();
 datam = shiftRight(datam);
  PORTA.F1  = datam.F0;
 delay_ms(1);
  PORTA.F1  = 0;
 if(startbit == 0)
 {
 wait_for_zero_crossing();
  PORTA.F1  = !datam.F0;
 delay_ms(1);
  PORTA.F1  = 0;
 }
 }
 return;
}

void x10_write(char house_code2, char key_code2)
{
 char i;
 i = 0;
 while (House_Code_Table[i] != house_code2)
 i++;
 house_code2 = i;
 if(key_code2 < 16)
 {
 i = 0;
 while (Key_Code_Table[i] != key_code2)
 i++;
 key_code2 = i;
 }
 x10_write_bits(7 * 2, 4, 1);
 x10_write_bits(house_code2 * 2, 4, 0);
 x10_write_bits(key_code2 * 2, 5, 0);
 x10_write_bits(0, 6, 1);
 return;
}

char x10_read_bits(char num)
{
char ic, dataval;

 for(ic = 1; ic <= num; ++ic)
 {
 wait_for_zero_crossing();
 delay_us(150);
 if ( PORTA.F2  == 1)
 {
 setbit = 128;
 }
 else
 {
 setbit = 0;
 }
 dataval = dataval + setbit;
 dataval = shiftRight(dataval);
 wait_for_zero_crossing();
 delay_us(150);
 }
 for(ic = 0; ic < 7 - num; ++ic)
 {
 dataval = shiftRight(dataval);
 }
 return(dataval);
}

void x10_read()
{
 x10_read_bits(2);
 house_code = x10_read_bits(4);
 house_code = House_Code_Table[house_code];
 key_code = x10_read_bits(5);
 if(key_code < 16)
 key_code = Key_Code_Table[key_code];
}

void x10Trans(char House, char Chan, char OnOff)
{
 x10_write(House, Chan);
 x10_write(House, Chan);
 Delay_ms(1000);
 x10_write(House, OnOff);
 x10_write(House, OnOff);
}

void Display_X10(char row, char HousePos, char ChanPos, char StatusPos)
{
 if(Rcv_Data())
 {
 x10_read();

 if (key_code < 19)
 {
 temp = key_code;
 }

 LCD_Chr(row, HousePos, house_code);
 BytetoStr(temp, txt4);
 LCD_Out(row, ChanPos, txt4);
 if (key_code == 20) LCD_Out(row, StatusPos, "ON ");
 if (key_code == 28) LCD_Out(row, StatusPos, "OFF");
 Delay1000ms();
 }
}
#line 36 "C:/Evil Genius/MikroProC/P16F887/x10 Demo Program/x10Demo.c"
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;


sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;
extern char x10_read_bits(void);
char txt[4], trans[4];

void DisplayMess1()
{
 LCD_Out(1, 1, "HC  Dev  On/Off ");
}

void DisplayMess2()
{
 LCD_Out(2, 1, "House 'A' Ch 10 ");
}

void DisplayMess3()
{
 LCD_Out(2, 1, "                ");
}

void main()
{

 ANSEL = 0b00000000;
 ANSELH = 0b00000000;
 ADCON1 = 0b00000000;
 PORTA = 0b00000000;
 PORTB = 0b00000000;
 PORTC = 0b00000000;
 PORTD = 0b00000000;
 TRISA = 0b00000101;
 TRISB = 0b00000000;
 TRISC = 0b10111101;
 TRISD = 0b11111111;
 TRISE = 0b00000111;
 Lcd_Init();
 LCD_Cmd(_LCD_CLEAR);
 LCD_Cmd(_LCD_CURSOR_OFF);
 Delay1000ms();

 LCD_Out(1, 1, "X10 Demo Program");
 LCD_Out(2, 1, "for P16F887     ");
 Delay2000ms();
 DisplayMess1();
 DisplayMess3();


 while (1 == 1)
 {
 if (PORTD.F0 == 0)
 {
 while (PORTD.F0 == 0)
 {
 }
 LCD_Out(1, 1, "X10 Transmit ON ");
 DisplayMess2();
 x10Trans('A', 10,  20 );
 Delay1000ms();
 DisplayMess1();
 DisplayMess3();
 }
 if (PORTD.F1 == 0)
 {
 while (PORTD.F1 == 0)
 {
 }
 LCD_Out(1, 1, "X10 Transmit OFF");
 DisplayMess2();
 x10Trans('A', 10,  28 );
 Delay1000ms();
 DisplayMess1();
 DisplayMess3();
 }
 Display_X10(2, 1, 3, 8);
 }
}
